package ap.proof;

import ap.terfor.TermOrder
import ap.util.Debug

object ProofTreeOneChild {
  
  private val AC = Debug.AC_PROOF_TREE

}

/**
 * Common superclass for proof trees that have exactly one direct subtree. Such
 * trees know about two <code>TermOrder</code>s: the <code>TermOrder</code> of
 * the closing constraint coming from the subtree, and the
 * <code>TermOrder</code> of the constraint of this <code>ProofTree</code>
 */
trait ProofTreeOneChild extends ProofTree {

  //////////////////////////////////////////////////////////////////////////////
  Debug.assertCtor(ProofTreeOneChild.AC,
                   subtreeOrder isSortingOf subtree.closingConstraint)
  //////////////////////////////////////////////////////////////////////////////
   
  def subtree : ProofTree
   
  protected def subtreeOrder : TermOrder
  
}
